# To increase robustness of what we send to central monitoring, filter out
# events that don't look valid before we try to send them to cental monitoring

<filter **>
  @type grep
  # timestamp must be a string composed of numbers (milliseconds since epoch)
  # In particular this filters out empty string values.
  <and>
      <regexp>
        key timestamp
        pattern /^\d+$/
      </regexp>
  </and>
</filter>

<filter **>
  @type record_modifier
  # Truncate extremely long log lines (> 32K) to avoid "BufferChunkOverflowError"
  remove_keys _dummy_
  <record>
    _dummy_ ${if record.has_key?('raw') && record['raw'].length > 32000; record['raw'] = record['raw'][0...32000] + "..."; end; nil }
  </record>
</filter>
